unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, shellapi, registry;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Button1: TButton;
    Label1: TLabel;
    Button2: TButton;
    OpenDialog1: TOpenDialog;
    Button3: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    procedure WMCopyData(var Msg: TWMCopyData); message WM_COPYDATA;
    function WhereIsNapi : string ;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}


function TForm1.WhereIsNapi() : string;
var
  Reg : TRegistry;
begin
  result := '';
  Reg := TRegistry.Create;
  try
    Reg.RootKey := HKEY_LOCAL_MACHINE;
    if Reg.KeyExists('SOFTWARE\Napiprojekt') then
    begin
      Reg.OpenKey('SOFTWARE\Napiprojekt', False);
      if fileexists(Reg.ReadString('Path')) then
         result := Reg.ReadString('Path');
    end;
  finally
    Reg.Free;
  end;
end;



procedure TForm1.WMCopyData(var Msg: TWMCopyData);
var
  sText: array[0..99] of Char;
begin
  StrLCopy(sText, Msg.CopyDataStruct.lpData, Msg.CopyDataStruct.cbData);
  showmessage('ODEBRANO WIADOMOSC OD NAPIPROJEKT: '+sText);

  (*  MOLIWE KOMUNIKATY:
  "Brak dostpu do pliku" - Napiprojekt nie potrafi uzyska dostpu do pliku z wskazanym filmem
  "Nie znaleziono napisw" - Napisw do podanego filmu nie ma w bazie
  "Zainstaluj now wersj Napiprojekt" - Zainstalowana wersja Napiprojekt zostaa zablokowana, z reguy blokowane s wersje w ktrych zostanie wykryty powany bd.
  "Brak poczenia z internetem" -
  "Serwer off-line" - Serwer z napisami jest off-line
  "Nieznany bd" -
  "Pobrano napisy" - Napiprojekt pobra napisy, cieka do napisw jest identyczna jak do pliku z filmem, pliki roni si tylko rozszerzeniem - napisy posiadaj rozszerzenie TXT*)
end;




procedure TForm1.Button1Click(Sender: TObject);
var
  sciezka, Par : string;

begin
  sciezka := WhereIsNapi();
  Par := format('"%s" -pobierz -handle=%d',[edit1.text, self.Handle]) ;  //ustawiamy parametry, handle jest potrzebne aby wiedzial gdzie zwrocic wiadomosc

  if(sciezka<>'') then
    ShellExecute(0, 'open', pchar(sciezka), pchar(par), '', SW_SHOWNORMAL)
  else showmessage('Napiprojekt niezainstalowany!');
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  if opendialog1.Execute then edit1.Text := opendialog1.FileName ;
end;

procedure TForm1.Button3Click(Sender: TObject);
var
  sciezka, Par : string;
begin
  sciezka := WhereIsNapi();
  Par := format('"%s" -opis',[edit1.text]) ;  //ustawiamy parametry

  if(sciezka<>'') then
    ShellExecute(0, 'open', pchar(sciezka), pchar(par), '', SW_SHOWNORMAL)  
  else showmessage('Napiprojekt niezainstalowany!');
end;

end.
